"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const gpu = __importStar(require("gpu-compute"));
const fs_1 = require("fs");
exports.searchAndReplace = {
    "float round(float);": gpu.functionStrings.round,
    "float floatEquals(float, float);": gpu.functionStrings.floatEquals,
    "float floatNotEquals(float, float);": gpu.functionStrings.floatNotEquals,
    "float floatLessThan(float, float);": gpu.functionStrings.floatLessThan,
    "float floatGreaterThan(float, float);": gpu.functionStrings.floatGreaterThan,
    "float floatLessThanOrEqual(float, float);": gpu.functionStrings.floatLessThanOrEqual,
    "float floatGreaterThanOrEqual(float, float);": gpu.functionStrings.floatGreaterThanOrEqual,
    "float vec2ToUint16(vec2);": gpu.functionStrings.vec2ToUint16,
    "vec2 uint16ToVec2(float);": gpu.functionStrings.uint16ToVec2
};
const transform64 = fs_1.readFileSync(require.resolve("./shaders/00_transform64.frag"), "utf8");
const sort64 = fs_1.readFileSync(require.resolve("./shaders/01_sort64.frag"), "utf8");
const untransform64 = fs_1.readFileSync(require.resolve("./shaders/02_untransform64.frag"), "utf8");
var transform64Shader;
var sort64Shader;
var untransform64Shader;
const transform32 = fs_1.readFileSync(require.resolve("./shaders/00_transform32.frag"), "utf8");
const sort32 = fs_1.readFileSync(require.resolve("./shaders/01_sort32.frag"), "utf8");
const untransform32 = fs_1.readFileSync(require.resolve("./shaders/02_untransform32.frag"), "utf8");
var transform32Shader;
var sort32Shader;
var untransform32Shader;
function getTransform64Shader() {
    if (!transform64Shader)
        transform64Shader = new gpu.ComputeShader(transform64, exports.searchAndReplace);
    return transform64Shader;
}
exports.getTransform64Shader = getTransform64Shader;
function getSort64Shader() {
    if (!sort64Shader)
        sort64Shader = new gpu.ComputeShader(sort64, exports.searchAndReplace);
    return sort64Shader;
}
exports.getSort64Shader = getSort64Shader;
function getUntransform64Shader() {
    if (!untransform64Shader)
        untransform64Shader = new gpu.ComputeShader(untransform64, exports.searchAndReplace);
    return untransform64Shader;
}
exports.getUntransform64Shader = getUntransform64Shader;
function getTransform32Shader() {
    if (!transform32Shader)
        transform32Shader = new gpu.ComputeShader(transform32, exports.searchAndReplace);
    return transform32Shader;
}
exports.getTransform32Shader = getTransform32Shader;
function getSort32Shader() {
    if (!sort32Shader)
        sort32Shader = new gpu.ComputeShader(sort32, exports.searchAndReplace);
    return sort32Shader;
}
exports.getSort32Shader = getSort32Shader;
function getUntransform32Shader() {
    if (!untransform32Shader)
        untransform32Shader = new gpu.ComputeShader(untransform32, exports.searchAndReplace);
    return untransform32Shader;
}
exports.getUntransform32Shader = getUntransform32Shader;
function initializeShaders() {
    getTransform64Shader();
    getSort64Shader();
    getUntransform64Shader();
    getTransform32Shader();
    getSort32Shader();
    getUntransform32Shader();
}
exports.initializeShaders = initializeShaders;
//# sourceMappingURL=initialize.js.map