"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function countAsync(rdx, arr, i, callback) {
    const start = Date.now();
    while (i < arr.length) {
        rdx[arr[i++]]++;
        if (!(i % 65536) && Date.now() - start > 1000 / 90) {
            requestAnimationFrame(() => countAsync(rdx, arr, i, callback));
            return;
        }
    }
    callback();
}
function fillAsync(rdx, arr, i, n, callback) {
    const start = Date.now();
    while (i < arr.length && n < rdx.length) {
        arr.fill(n, i, (i += rdx[n++]));
        if (Date.now() - start > 1000 / 90) {
            requestAnimationFrame(() => fillAsync(rdx, arr, i, n, callback));
            return;
        }
    }
    callback(i);
}
function radixSortAsync(arr, radix) {
    return new Promise(resolve => {
        const rdx = new Array(radix).fill(0);
        countAsync(rdx, arr, 0, () => {
            fillAsync(rdx, arr, 0, 0, () => {
                resolve();
            });
        });
    });
}
exports.radixSortAsync = radixSortAsync;
function radixSortSignedAsync(arr, radix) {
    return new Promise(resolve => {
        const rdx = new Array(radix).fill(0);
        countAsync(rdx, arr, 0, () => {
            fillAsync(rdx, arr, 0, radix / 2, i => {
                fillAsync(rdx, arr, i, 0, () => {
                    resolve();
                });
            });
        });
    });
}
exports.radixSortSignedAsync = radixSortSignedAsync;
//# sourceMappingURL=radix.js.map