import * as gpu from "gpu-compute";
import { Uniforms } from "gpu-compute/lib/renderTarget";
export declare const isBigEndian: boolean;
export declare const isLittleEndian: boolean;
export declare class BitonicUniformGenerator {
    private readonly target;
    private readonly parameters;
    private readonly emptyTexelCount;
    constructor(target: gpu.RenderTarget, kind: string, emptyTexelCount: number);
    generate(): IterableIterator<bitonicShaderAndUniforms>;
    private generateTransformerUniforms;
    private generateSorterUniforms;
    private generateUntransformerUniforms;
}
export interface bitonicTransformerUniforms extends Uniforms {
    u_bytes: gpu.RenderTarget;
    u_width: number;
    u_mode: number;
    u_endianness: number;
    u_dataDelimX: number;
    u_dataDelimY: number;
}
export interface bitonicSorterUniforms extends Uniforms {
    u_bytes: gpu.RenderTarget;
    u_width: number;
    u_blockSizeX: number;
    u_blockSizeY: number;
    u_regionSizeX: number;
    u_regionSizeY: number;
}
export interface bitonicUntransformerUniforms extends Uniforms {
    u_bytes: gpu.RenderTarget;
    u_width: number;
    u_mode: number;
    u_endianness: number;
}
export interface bitonicShaderAndUniforms {
    shader: gpu.ComputeShader;
    uniforms: bitonicTransformerUniforms | bitonicSorterUniforms | bitonicUntransformerUniforms;
}
